# Class TangentPlaneTransformer

java.lang.Object
uk.ac.starlink.ttools.plot2.layer.TangentPlaneTransformer

public class TangentPlaneTransformer extends Object
Performs normalised 3D coordinate transformations equivalent to displacements from the origin in the tangent plane.

This object can deal with the data->view transformation represented by a `SkyDataGeom`. The input tangent position is in view coordinates, but the input displacements on that plane correspond to displacements along the axes of data coordinates. That may seem baroque, but it corresponds to what sky-based `MultiPointCoordSet` implementations are likely to be able to supply.

Since:
  21 Feb 2013
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`TangentPlaneTransformer(double[] xyz0, SkyDataGeom geom)`
Constructs a transformer for the tangent plane centred at a given normalised vector.

## Method Summary

Modifier and Type
Method
Description
`void`
`displace(double xi, double eta, double[] xyz1)`
Determines the normalised 3D position in view coordinates of a position at given coordinates in this object's tangent plane.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### TangentPlaneTransformer

public TangentPlaneTransformer(double[] xyz0, SkyDataGeom geom)
Constructs a transformer for the tangent plane centred at a given normalised vector.

Parameters:
  `xyz0` - normalised 3D coordinates in the view coordinate system at the centre of tangent plane
  `geom` - geom object representing data->view coordinate system rotation

## Method Details

### displace

public void displace(double xi, double eta, double[] xyz1)
Determines the normalised 3D position in view coordinates of a position at given coordinates in this object's tangent plane.

Parameters:
  `xi` - horizontal displacement in data coordinates from tangent plane origin (tangent point)
  `eta` - vertical displacement in data coordinates from tangent plane origin (tangent point)
  `xyz1` - 3-element array into which normalised 3D coordinates of result position in view coordinates are written